> For the complete documentation index, see [llms.txt](https://mariadb.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://mariadb.com/docs/analytics/mariadb-columnstore/reference/cmapi/mode-set.md).

# mode-set

Sets all ColumnStore nodes to read-only or read-write.

See [CMAPI](/docs/analytics/mariadb-columnstore/reference/cmapi.md) for detail on REST API endpoint, required headers, and other available actions.

## Description

Upon successful `mode-set` call CMAPI re-configures MariaDB ColumnStore to the designated mode, either read-only or read/write operation.

Call made via HTTPS `PUT`, with authentication via shared secret using the `x-api-key` header.

JSON data required for this call:

| Key       | Value                                                                  |
| --------- | ---------------------------------------------------------------------- |
| `timeout` | Maximum time in seconds to wait for completion of `mode-set` operation |
| `mode`    | Accepted values: `readonly` for read-only, `readwrite` for read/write. |

Bash aliases `mcsReadOnly` and `mcsReadWrite` are available starting with ColumnStore 5.5.2.

## Examples

### Executing cURL Manually

CMAPI calls can be made from the command-line using cURL.

Replace the CMAPI\_API\_KEY and sample data in the following example:

```bash
curl -k -s -X PUT https://mcs1:8640/cmapi/0.4.0/cluster/mode-set \
   --header 'Content-Type:application/json' \
   --header 'x-api-key:<CMAPI_API_KEY>' \
   --data '{"timeout": 20, "mode": "readwrite"}' \
   | jq .
```

In this example, `jq` produces human-readable output from the returned JSON response.

### Executing the Bash Aliases

Starting with Enterprise ColumnStore 5.5.2, if your `bash` shell is configured to source the `columnstoreAlias` shell script, this command can be executed using the `mcsReadOnly` and `mcsReadWrite` aliases. The alias executes `curl` and `jq`, so both programs must be installed on the system.

The aliases automatically retrieve the IP address for the primary node using the `mcsGetConfig` command. The aliases automatically retrieve the API key by reading `/etc/columnstore/cmapi_server.conf`.

To set the deployment's mode to read-only:

```bash
mcsReadOnly
```

To set the deployment's mode to read-write:

```bash
mcsReadWrite
```

These aliases use `jq` produces human-readable output from the returned JSON response.

<sub>*This page is: Copyright © 2025 MariaDB. All rights reserved.*</sub>

{% @marketo/form formId="4316" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://mariadb.com/docs/analytics/mariadb-columnstore/reference/cmapi/mode-set.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
